// Garden Gnome Software - Skin
// Pano2VR 6.0 beta3/16902
// Filename: mp_update.ggsk
// Generated Mon Jun 11 15:39:50 2018

function pano2vrSkin(player,base) {
	player.addVariable('vis_iframe_popup', 2);
	player.setVariableValue('vis_iframe_popup', false);
	var me=this;
	var flag=false;
	var hotspotTemplates=[];
	var skinKeyPressed = 0;
	this.player=player;
	this.player.skinObj=this;
	this.divSkin=player.divSkin;
	this.ggUserdata=me.player.userdata;
	this.lastSize={ w: -1,h: -1 };
	var basePath="";
	// auto detect base path
	if (base=='?') {
		var scripts = document.getElementsByTagName('script');
		for(var i=0;i<scripts.length;i++) {
			var src=scripts[i].src;
			if (src.indexOf('skin.js')>=0) {
				var p=src.lastIndexOf('/');
				if (p>=0) {
					basePath=src.substr(0,p+1);
				}
			}
		}
	} else
	if (base) {
		basePath=base;
	}
	this.elementMouseDown=[];
	this.elementMouseOver=[];
	var cssPrefix='';
	var domTransition='transition';
	var domTransform='transform';
	var prefixes='Webkit,Moz,O,ms,Ms'.split(',');
	var i;
	if (typeof document.body.style['transform'] == 'undefined') {
		for(var i=0;i<prefixes.length;i++) {
			if (typeof document.body.style[prefixes[i] + 'Transform'] !== 'undefined') {
				cssPrefix='-' + prefixes[i].toLowerCase() + '-';
				domTransition=prefixes[i] + 'Transition';
				domTransform=prefixes[i] + 'Transform';
			}
		}
	}
	
	this.player.setMargins(0,0,0,0);
	
	this.updateSize=function(startElement) {
		var stack=[];
		stack.push(startElement);
		while(stack.length>0) {
			var e=stack.pop();
			if (e.ggUpdatePosition) {
				e.ggUpdatePosition();
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
	}
	
	var parameterToTransform=function(p) {
		var hs='translate(' + p.rx + 'px,' + p.ry + 'px) rotate(' + p.a + 'deg) scale(' + p.sx + ',' + p.sy + ')';
		return hs;
	}
	
	this.findElements=function(id,regex) {
		var r=[];
		var stack=[];
		var pat=new RegExp(id,'');
		stack.push(me.divSkin);
		while(stack.length>0) {
			var e=stack.pop();
			if (regex) {
				if (pat.test(e.ggId)) r.push(e);
			} else {
				if (e.ggId==id) r.push(e);
			}
			if (e.hasChildNodes()) {
				for(var i=0;i<e.childNodes.length;i++) {
					stack.push(e.childNodes[i]);
				}
			}
		}
		return r;
	}
	
	this.addSkin=function() {
		var hs='';
		this.ggCurrentTime=new Date().getTime();
		this._iframe_site=document.createElement('div');
		this._iframe_site.ggId="iframe_site";
		this._iframe_site.ggDx=0;
		this._iframe_site.ggDy=1;
		this._iframe_site.ggParameter={ rx:0,ry:0,a:0,sx:0,sy:0 };
		this._iframe_site.ggVisible=true;
		this._iframe_site.className="ggskin ggskin_container ";
		this._iframe_site.ggType='container';
		hs ='';
		hs+='height : 717px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 800px;';
		hs+='pointer-events:none;';
		this._iframe_site.setAttribute('style',hs);
		this._iframe_site.style[domTransform + 'Origin']='50% 50%';
		this._iframe_site.style[domTransform]=parameterToTransform(this._iframe_site.ggParameter);
		me._iframe_site.ggIsActive=function() {
			return false;
		}
		me._iframe_site.ggElementNodeId=function() {
			return me.player.getCurrentNode();
		}
		me._iframe_site.logicBlock_scaling = function() {
			var newLogicStateScaling;
			if (
				(me.player.getVariableValue('vis_iframe_popup') == true)
			)
			{
				newLogicStateScaling = 0;
			}
			else {
				newLogicStateScaling = -1;
			}
			if (me._iframe_site.ggCurrentLogicStateScaling != newLogicStateScaling) {
				me._iframe_site.ggCurrentLogicStateScaling = newLogicStateScaling;
				me._iframe_site.style[domTransition]='' + cssPrefix + 'transform 1000ms ease 0ms';
				if (me._iframe_site.ggCurrentLogicStateScaling == 0) {
					me._iframe_site.ggParameter.sx = 1;
					me._iframe_site.ggParameter.sy = 1;
					me._iframe_site.style[domTransform]=parameterToTransform(me._iframe_site.ggParameter);
				}
				else {
					me._iframe_site.ggParameter.sx = 0;
					me._iframe_site.ggParameter.sy = 0;
					me._iframe_site.style[domTransform]=parameterToTransform(me._iframe_site.ggParameter);
				}
			}
		}
		this._iframe_site.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._iframe_popup=document.createElement('div');
		this._iframe_popup.ggId="iframe_popup";
		this._iframe_popup.ggDx=0;
		this._iframe_popup.ggDy=0;
		this._iframe_popup.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._iframe_popup.ggVisible=true;
		this._iframe_popup.className="ggskin ggskin_container ";
		this._iframe_popup.ggType='container';
		hs ='';
		hs+='z-index: 99;';
		hs+='cursor : pointer;';
		hs+='height : 717px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 800px;';
		hs+='pointer-events:none;';
		this._iframe_popup.setAttribute('style',hs);
		this._iframe_popup.style[domTransform + 'Origin']='50% 50%';
		me._iframe_popup.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._iframe_popup.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.player.getCurrentNode();
		}
		this._iframe_popup.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._iframe_popup_body=document.createElement('div');
		this._iframe_popup_body__text=document.createElement('div');
		this._iframe_popup_body.className='ggskin ggskin_textdiv';
		this._iframe_popup_body.ggTextDiv=this._iframe_popup_body__text;
		this._iframe_popup_body.ggId="iframe_popup_body";
		this._iframe_popup_body.ggDx=1;
		this._iframe_popup_body.ggDy=10;
		this._iframe_popup_body.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._iframe_popup_body.ggVisible=true;
		this._iframe_popup_body.className="ggskin ggskin_text ";
		this._iframe_popup_body.ggType='text';
		hs ='';
		hs+='cursor : pointer;';
		hs+='height : 700px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 800px;';
		hs+='pointer-events:auto;';
		this._iframe_popup_body.setAttribute('style',hs);
		this._iframe_popup_body.style[domTransform + 'Origin']='50% 50%';
		hs ='position:absolute;';
		hs+='left: 0px;';
		hs+='top:  0px;';
		hs+='width: 800px;';
		hs+='height: 700px;';
		hs+='background: #ffffff;';
		hs+='border: 1px solid #000000;';
		hs+='color: #000000;';
		hs+='text-align: center;';
		hs+='white-space: nowrap;';
		hs+='padding: 0px 1px 0px 1px;';
		hs+='overflow: hidden;';
		this._iframe_popup_body__text.setAttribute('style',hs);
		this._iframe_popup_body__text.innerHTML="<iframe src=\"http:\/\/www.lookin360.co.uk\/work\/24medway\/iframes\/empty_full\/index.html\" style=\"border:0px #ffffff none;\" name=\"myiFrame\" scrolling=\"no\" frameborder=\"1\" marginheight=\"0px\" marginwidth=\"0px\" height=\"700px\" width=\"800px\" allowfullscreen><\/iframe>";
		this._iframe_popup_body.appendChild(this._iframe_popup_body__text);
		me._iframe_popup_body.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._iframe_popup_body.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.player.getCurrentNode();
		}
		this._iframe_popup_body.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._iframe_popup.appendChild(this._iframe_popup_body);
		this._iframe_popup_close=document.createElement('div');
		this._iframe_popup_close__img=document.createElement('img');
		this._iframe_popup_close__img.className='ggskin ggskin_svg';
		this._iframe_popup_close__img.setAttribute('src',basePath + 'images/iframe_popup_close.svg');
		this._iframe_popup_close__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;pointer-events:none;;');
		this._iframe_popup_close__img['ondragstart']=function() { return false; };
		this._iframe_popup_close.appendChild(this._iframe_popup_close__img);
		this._iframe_popup_close__imgo=document.createElement('img');
		this._iframe_popup_close__imgo.className='ggskin ggskin_svg';
		this._iframe_popup_close__imgo.setAttribute('src',basePath + 'images/iframe_popup_close__o.svg');
		this._iframe_popup_close__imgo.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;visibility:hidden;pointer-events:none;;');
		this._iframe_popup_close__imgo['ondragstart']=function() { return false; };
		this._iframe_popup_close.appendChild(this._iframe_popup_close__imgo);
		this._iframe_popup_close.ggId="iframe_popup_close";
		this._iframe_popup_close.ggDx=0;
		this._iframe_popup_close.ggDy=-342;
		this._iframe_popup_close.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._iframe_popup_close.ggVisible=true;
		this._iframe_popup_close.className="ggskin ggskin_svg ";
		this._iframe_popup_close.ggType='svg';
		hs ='';
		hs+='cursor : pointer;';
		hs+='height : 32px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 32px;';
		hs+='pointer-events:auto;';
		this._iframe_popup_close.setAttribute('style',hs);
		this._iframe_popup_close.style[domTransform + 'Origin']='50% 50%';
		me._iframe_popup_close.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._iframe_popup_close.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.player.getCurrentNode();
		}
		this._iframe_popup_close.onclick=function (e) {
			me.player.setVariableValue('vis_iframe_popup', false);
		}
		this._iframe_popup_close.onmouseover=function (e) {
			me._iframe_popup_close__img.style.visibility='hidden';
			me._iframe_popup_close__imgo.style.visibility='inherit';
		}
		this._iframe_popup_close.onmouseout=function (e) {
			me._iframe_popup_close__img.style.visibility='inherit';
			me._iframe_popup_close__imgo.style.visibility='hidden';
		}
		this._iframe_popup_close.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._iframe_popup.appendChild(this._iframe_popup_close);
		this._iframe_site.appendChild(this._iframe_popup);
		this.divSkin.appendChild(this._iframe_site);
		this._van_morrison=document.createElement('div');
		this._van_morrison.ggId="van_morrison";
		this._van_morrison.ggDx=0;
		this._van_morrison.ggDy=-23;
		this._van_morrison.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._van_morrison.ggVisible=true;
		this._van_morrison.className="ggskin ggskin_container ";
		this._van_morrison.ggType='container';
		hs ='';
		hs+='height : 546.5px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 500px;';
		hs+='pointer-events:none;';
		this._van_morrison.setAttribute('style',hs);
		this._van_morrison.style[domTransform + 'Origin']='50% 50%';
		me._van_morrison.ggIsActive=function() {
			return false;
		}
		me._van_morrison.ggElementNodeId=function() {
			return me.player.getCurrentNode();
		}
		this._van_morrison.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._image_1=document.createElement('div');
		this._image_1__img=document.createElement('img');
		this._image_1__img.className='ggskin ggskin_image';
		this._image_1__img.setAttribute('src',basePath + 'images/image_1.png');
		this._image_1__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;pointer-events:none;;');
		this._image_1__img.className='ggskin ggskin_image';
		this._image_1__img['ondragstart']=function() { return false; };
		me.player.checkLoaded.push(this._image_1__img);
		this._image_1.appendChild(this._image_1__img);
		this._image_1.ggId="Image 1";
		this._image_1.ggDx=0;
		this._image_1.ggDy=23;
		this._image_1.ggParameter={ rx:0,ry:0,a:0,sx:0,sy:0 };
		this._image_1.ggVisible=true;
		this._image_1.className="ggskin ggskin_image ";
		this._image_1.ggType='image';
		hs ='';
		hs+='cursor : pointer;';
		hs+='height : 500px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 500px;';
		hs+='pointer-events:auto;';
		this._image_1.setAttribute('style',hs);
		this._image_1.style[domTransform + 'Origin']='50% 50%';
		this._image_1.style[domTransform]=parameterToTransform(this._image_1.ggParameter);
		me._image_1.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._image_1.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.player.getCurrentNode();
		}
		this._image_1.onclick=function (e) {
			var flag=me._image_1.ggScaleActive;
			if (me.player.transitionsDisabled) {
				me._image_1.style[domTransition]='none';
			} else {
				me._image_1.style[domTransition]='all 250ms ease-out 0ms';
			}
			if (flag) {
				me._image_1.ggParameter.sx=0;me._image_1.ggParameter.sy=0;
				me._image_1.style[domTransform]=parameterToTransform(me._image_1.ggParameter);
			} else {
				me._image_1.ggParameter.sx=1;me._image_1.ggParameter.sy=1;
				me._image_1.style[domTransform]=parameterToTransform(me._image_1.ggParameter);
			}
			me._image_1.ggScaleActive=!flag;
		}
		this._image_1.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._van_morrison.appendChild(this._image_1);
		this.divSkin.appendChild(this._van_morrison);
		this._little_girls=document.createElement('div');
		this._little_girls.ggId="little_girls";
		this._little_girls.ggDx=0;
		this._little_girls.ggDy=-23;
		this._little_girls.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._little_girls.ggVisible=true;
		this._little_girls.className="ggskin ggskin_container ";
		this._little_girls.ggType='container';
		hs ='';
		hs+='height : 647.5px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 336px;';
		hs+='pointer-events:none;';
		this._little_girls.setAttribute('style',hs);
		this._little_girls.style[domTransform + 'Origin']='50% 50%';
		me._little_girls.ggIsActive=function() {
			return false;
		}
		me._little_girls.ggElementNodeId=function() {
			return me.player.getCurrentNode();
		}
		this._little_girls.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._image_2=document.createElement('div');
		this._image_2__img=document.createElement('img');
		this._image_2__img.className='ggskin ggskin_image';
		this._image_2__img.setAttribute('src',basePath + 'images/image_2.png');
		this._image_2__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;pointer-events:none;;');
		this._image_2__img.className='ggskin ggskin_image';
		this._image_2__img['ondragstart']=function() { return false; };
		me.player.checkLoaded.push(this._image_2__img);
		this._image_2.appendChild(this._image_2__img);
		this._image_2.ggId="Image 2";
		this._image_2.ggDx=0;
		this._image_2.ggDy=23;
		this._image_2.ggParameter={ rx:0,ry:0,a:0,sx:0,sy:0 };
		this._image_2.ggVisible=true;
		this._image_2.className="ggskin ggskin_image ";
		this._image_2.ggType='image';
		hs ='';
		hs+='height : 600px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 336px;';
		hs+='pointer-events:auto;';
		this._image_2.setAttribute('style',hs);
		this._image_2.style[domTransform + 'Origin']='50% 50%';
		this._image_2.style[domTransform]=parameterToTransform(this._image_2.ggParameter);
		me._image_2.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._image_2.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.player.getCurrentNode();
		}
		this._image_2.onclick=function (e) {
			var flag=me._image_2.ggScaleActive;
			if (me.player.transitionsDisabled) {
				me._image_2.style[domTransition]='none';
			} else {
				me._image_2.style[domTransition]='all 250ms ease-out 0ms';
			}
			if (flag) {
				me._image_2.ggParameter.sx=0;me._image_2.ggParameter.sy=0;
				me._image_2.style[domTransform]=parameterToTransform(me._image_2.ggParameter);
			} else {
				me._image_2.ggParameter.sx=1;me._image_2.ggParameter.sy=1;
				me._image_2.style[domTransform]=parameterToTransform(me._image_2.ggParameter);
			}
			me._image_2.ggScaleActive=!flag;
		}
		this._image_2.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._little_girls.appendChild(this._image_2);
		this.divSkin.appendChild(this._little_girls);
		this.player.addListener('sizechanged', function() {
			me.updateSize(me.divSkin);
		});
	};
	this.hotspotProxyClick=function(id) {
	}
	this.hotspotProxyDoubleClick=function(id) {
	}
	this.hotspotProxyOver=function(id) {
	}
	this.hotspotProxyOut=function(id) {
	}
	me.callChildLogicBlocksHotspot_ht_info_configloaded = function(){
		if(hotspotTemplates['ht_info']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_info'].length; i++) {
				if (hotspotTemplates['ht_info'][i]._tt_ht_node1.logicBlock_position) {
					hotspotTemplates['ht_info'][i]._tt_ht_node1.logicBlock_position();
				}
			}
		}
	}
	me.callChildLogicBlocksHotspot_ht_info_mouseover = function(){
		if(hotspotTemplates['ht_info']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_info'].length; i++) {
				if (hotspotTemplates['ht_info'][i]._tt_ht_node1.logicBlock_visible) {
					hotspotTemplates['ht_info'][i]._tt_ht_node1.logicBlock_visible();
				}
			}
		}
	}
	me.callChildLogicBlocksHotspot_ht_scaleimage_configloaded = function(){
		if(hotspotTemplates['ht_scaleimage']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_scaleimage'].length; i++) {
				if (hotspotTemplates['ht_scaleimage'][i]._tt_ht_node0.logicBlock_position) {
					hotspotTemplates['ht_scaleimage'][i]._tt_ht_node0.logicBlock_position();
				}
			}
		}
	}
	me.callChildLogicBlocksHotspot_ht_scaleimage_mouseover = function(){
		if(hotspotTemplates['ht_scaleimage']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_scaleimage'].length; i++) {
				if (hotspotTemplates['ht_scaleimage'][i]._tt_ht_node0.logicBlock_visible) {
					hotspotTemplates['ht_scaleimage'][i]._tt_ht_node0.logicBlock_visible();
				}
			}
		}
	}
	me.callChildLogicBlocksHotspot_ht_scaleimage2_configloaded = function(){
		if(hotspotTemplates['ht_scaleimage2']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_scaleimage2'].length; i++) {
				if (hotspotTemplates['ht_scaleimage2'][i]._tt_ht_node.logicBlock_position) {
					hotspotTemplates['ht_scaleimage2'][i]._tt_ht_node.logicBlock_position();
				}
			}
		}
	}
	me.callChildLogicBlocksHotspot_ht_scaleimage2_mouseover = function(){
		if(hotspotTemplates['ht_scaleimage2']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_scaleimage2'].length; i++) {
				if (hotspotTemplates['ht_scaleimage2'][i]._tt_ht_node.logicBlock_visible) {
					hotspotTemplates['ht_scaleimage2'][i]._tt_ht_node.logicBlock_visible();
				}
			}
		}
	}
	this.player.addListener('changenodeid', function() {
		me.ggUserdata=me.player.userdata;
	});
	this.skinTimerEvent=function() {
		me.ggCurrentTime=new Date().getTime();
	};
	this.player.addListener('timer', this.skinTimerEvent);
	function SkinHotspotClass_ht_info(skinObj,hotspot) {
		var me=this;
		var flag=false;
		var hs='';
		this.player=skinObj.player;
		this.skin=skinObj;
		this.hotspot=hotspot;
		var nodeId=String(hotspot.url);
		nodeId=(nodeId.charAt(0)=='{')?nodeId.substr(1, nodeId.length - 2):'';
		this.ggUserdata=this.skin.player.getNodeUserdata(nodeId);
		this.elementMouseDown=[];
		this.elementMouseOver=[];
		this.findElements=function(id,regex) {
			return me.skin.findElements(id,regex);
		}
		this._ht_info=document.createElement('div');
		this._ht_info.ggId="ht_info";
		this._ht_info.ggDx=0;
		this._ht_info.ggDy=0;
		this._ht_info.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._ht_info.ggVisible=true;
		this._ht_info.className="ggskin ggskin_hotspot ";
		this._ht_info.ggType='hotspot';
		hs ='';
		hs+='height : 5px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 5px;';
		hs+='pointer-events:auto;';
		this._ht_info.setAttribute('style',hs);
		this._ht_info.style[domTransform + 'Origin']='50% 50%';
		me._ht_info.ggIsActive=function() {
			return me.player.getCurrentNode()==this.ggElementNodeId();
		}
		me._ht_info.ggElementNodeId=function() {
			return me.hotspot.url.substr(1, me.hotspot.url.length - 2);
		}
		this._ht_info.onclick=function (e) {
			me.player.setVariableValue('vis_iframe_popup', true);
			var list=me.findElements("tt_ht_node",true);
			while(list.length>0) {
				var e=list.pop();
				e.style[domTransition]='none';
				e.style.visibility='hidden';
				e.ggVisible=false;
			}
			me.skin.hotspotProxyClick(me.hotspot.id);
		}
		this._ht_info.ondblclick=function (e) {
			me.skin.hotspotProxyDoubleClick(me.hotspot.id);
		}
		this._ht_info.onmouseover=function (e) {
			me.player.setActiveHotspot(me.hotspot);
			me.elementMouseOver['ht_info']=true;
			me._tt_ht_node1.logicBlock_visible();
			me.skin.hotspotProxyOver(me.hotspot.id);
		}
		this._ht_info.onmouseout=function (e) {
			me.player.setActiveHotspot(null);
			me.elementMouseOver['ht_info']=false;
			me._tt_ht_node1.logicBlock_visible();
			me.skin.hotspotProxyOut(me.hotspot.id);
		}
		this._ht_info.ontouchend=function (e) {
			me.elementMouseOver['ht_info']=false;
			me._tt_ht_node1.logicBlock_visible();
		}
		this._ht_info.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._tt_ht_node1=document.createElement('div');
		this._tt_ht_node1__text=document.createElement('div');
		this._tt_ht_node1.className='ggskin ggskin_textdiv';
		this._tt_ht_node1.ggTextDiv=this._tt_ht_node1__text;
		this._tt_ht_node1.ggId="tt_ht_node";
		this._tt_ht_node1.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._tt_ht_node1.ggVisible=false;
		this._tt_ht_node1.className="ggskin ggskin_text ";
		this._tt_ht_node1.ggType='text';
		hs ='';
		hs+='z-index: 100;';
		hs+='height : 20px;';
		hs+='left : -50px;';
		hs+='position : absolute;';
		hs+='top : 21px;';
		hs+='visibility : hidden;';
		hs+='width : 100px;';
		hs+='pointer-events:auto;';
		this._tt_ht_node1.setAttribute('style',hs);
		this._tt_ht_node1.style[domTransform + 'Origin']='50% 50%';
		hs ='position:absolute;';
		hs+='cursor: default;';
		hs+='left: 0px;';
		hs+='top:  0px;';
		hs+='width: auto;';
		hs+='height: auto;';
		hs+='background: #000000;';
		hs+='background: rgba(0,0,0,0.666667);';
		hs+='border: 0px solid #000000;';
		hs+='color: rgba(255,255,255,1);';
		hs+='text-align: center;';
		hs+='white-space: nowrap;';
		hs+='padding: 2px 5px 2px 5px;';
		hs+='overflow: hidden;';
		this._tt_ht_node1__text.setAttribute('style',hs);
		this._tt_ht_node1__text.innerHTML=me.hotspot.title;
		this._tt_ht_node1.appendChild(this._tt_ht_node1__text);
		me._tt_ht_node1.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._tt_ht_node1.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		me._tt_ht_node1.logicBlock_position = function() {
			var newLogicStatePosition;
			if (
				(me.player.getIsMobile() == true)
			)
			{
				newLogicStatePosition = 0;
			}
			else {
				newLogicStatePosition = -1;
			}
			if (me._tt_ht_node1.ggCurrentLogicStatePosition != newLogicStatePosition) {
				me._tt_ht_node1.ggCurrentLogicStatePosition = newLogicStatePosition;
				me._tt_ht_node1.style[domTransition]='left 0s, top 0s';
				if (me._tt_ht_node1.ggCurrentLogicStatePosition == 0) {
					me._tt_ht_node1.style.left='-50px';
					me._tt_ht_node1.style.top='-47px';
				}
				else {
					me._tt_ht_node1.style.left='-50px';
					me._tt_ht_node1.style.top='21px';
				}
			}
		}
		me._tt_ht_node1.logicBlock_visible = function() {
			var newLogicStateVisible;
			if (
				(me.elementMouseOver['ht_info'] == true)
			)
			{
				newLogicStateVisible = 0;
			}
			else {
				newLogicStateVisible = -1;
			}
			if (me._tt_ht_node1.ggCurrentLogicStateVisible != newLogicStateVisible) {
				me._tt_ht_node1.ggCurrentLogicStateVisible = newLogicStateVisible;
				me._tt_ht_node1.style[domTransition]='left 0s, top 0s';
				if (me._tt_ht_node1.ggCurrentLogicStateVisible == 0) {
					me._tt_ht_node1.style.visibility=(Number(me._tt_ht_node1.style.opacity)>0||!me._tt_ht_node1.style.opacity)?'inherit':'hidden';
					me._tt_ht_node1.ggVisible=true;
				}
				else {
					me._tt_ht_node1.style.visibility="hidden";
					me._tt_ht_node1.ggVisible=false;
				}
			}
		}
		this._tt_ht_node1.ggUpdatePosition=function (useTransition) {
			this.style[domTransition]='none';
			this.ggTextDiv.style.left=((98-this.ggTextDiv.offsetWidth)/2) + 'px';
		}
		this._ht_info.appendChild(this._tt_ht_node1);
		this._ht_info_image=document.createElement('div');
		this._ht_info_image__img=document.createElement('img');
		this._ht_info_image__img.className='ggskin ggskin_svg';
		this._ht_info_image__img.setAttribute('src',basePath + 'images/ht_info_image.svg');
		this._ht_info_image__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;pointer-events:none;;');
		this._ht_info_image__img['ondragstart']=function() { return false; };
		this._ht_info_image.appendChild(this._ht_info_image__img);
		this._ht_info_image__imgo=document.createElement('img');
		this._ht_info_image__imgo.className='ggskin ggskin_svg';
		this._ht_info_image__imgo.setAttribute('src',basePath + 'images/ht_info_image__o.svg');
		this._ht_info_image__imgo.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;visibility:hidden;pointer-events:none;;');
		this._ht_info_image__imgo['ondragstart']=function() { return false; };
		this._ht_info_image.appendChild(this._ht_info_image__imgo);
		this._ht_info_image.ggId="ht_info_image";
		this._ht_info_image.ggDx=0;
		this._ht_info_image.ggDy=0;
		this._ht_info_image.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._ht_info_image.ggVisible=true;
		this._ht_info_image.className="ggskin ggskin_svg ";
		this._ht_info_image.ggType='svg';
		hs ='';
		hs+='cursor : pointer;';
		hs+='height : 32px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 32px;';
		hs+='pointer-events:auto;';
		this._ht_info_image.setAttribute('style',hs);
		this._ht_info_image.style[domTransform + 'Origin']='50% 50%';
		me._ht_info_image.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._ht_info_image.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		this._ht_info_image.onmouseover=function (e) {
			me._ht_info_image__img.style.visibility='hidden';
			me._ht_info_image__imgo.style.visibility='inherit';
		}
		this._ht_info_image.onmouseout=function (e) {
			me._ht_info_image__img.style.visibility='inherit';
			me._ht_info_image__imgo.style.visibility='hidden';
		}
		this._ht_info_image.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._ht_info.appendChild(this._ht_info_image);
		this.__div = this._ht_info;
	};
	function SkinHotspotClass_ht_scaleimage(skinObj,hotspot) {
		var me=this;
		var flag=false;
		var hs='';
		this.player=skinObj.player;
		this.skin=skinObj;
		this.hotspot=hotspot;
		var nodeId=String(hotspot.url);
		nodeId=(nodeId.charAt(0)=='{')?nodeId.substr(1, nodeId.length - 2):'';
		this.ggUserdata=this.skin.player.getNodeUserdata(nodeId);
		this.elementMouseDown=[];
		this.elementMouseOver=[];
		this.findElements=function(id,regex) {
			return me.skin.findElements(id,regex);
		}
		this._ht_scaleimage=document.createElement('div');
		this._ht_scaleimage.ggId="ht_scaleimage";
		this._ht_scaleimage.ggDx=-196;
		this._ht_scaleimage.ggDy=-271;
		this._ht_scaleimage.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._ht_scaleimage.ggVisible=true;
		this._ht_scaleimage.className="ggskin ggskin_hotspot ";
		this._ht_scaleimage.ggType='hotspot';
		hs ='';
		hs+='height : 5px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 5px;';
		hs+='pointer-events:auto;';
		this._ht_scaleimage.setAttribute('style',hs);
		this._ht_scaleimage.style[domTransform + 'Origin']='50% 50%';
		me._ht_scaleimage.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._ht_scaleimage.ggElementNodeId=function() {
			return me.hotspot.url.substr(1, me.hotspot.url.length - 2);
		}
		this._ht_scaleimage.onclick=function (e) {
			var flag=me.skin._image_1.ggScaleActive;
			if (me.player.transitionsDisabled) {
				me.skin._image_1.style[domTransition]='none';
			} else {
				me.skin._image_1.style[domTransition]='all 500ms ease-out 0ms';
			}
			if (flag) {
				me.skin._image_1.ggParameter.sx=0;me.skin._image_1.ggParameter.sy=0;
				me.skin._image_1.style[domTransform]=parameterToTransform(me.skin._image_1.ggParameter);
			} else {
				me.skin._image_1.ggParameter.sx=1;me.skin._image_1.ggParameter.sy=1;
				me.skin._image_1.style[domTransform]=parameterToTransform(me.skin._image_1.ggParameter);
			}
			me.skin._image_1.ggScaleActive=!flag;
			var list=me.findElements("tt_ht_node",true);
			while(list.length>0) {
				var e=list.pop();
				e.style[domTransition]='none';
				e.style.visibility='hidden';
				e.ggVisible=false;
			}
			me.skin.hotspotProxyClick(me.hotspot.id);
		}
		this._ht_scaleimage.ondblclick=function (e) {
			me.skin.hotspotProxyDoubleClick(me.hotspot.id);
		}
		this._ht_scaleimage.onmouseover=function (e) {
			me.player.setActiveHotspot(me.hotspot);
			me.elementMouseOver['ht_scaleimage']=true;
			me._tt_ht_node0.logicBlock_visible();
			me.skin.hotspotProxyOver(me.hotspot.id);
		}
		this._ht_scaleimage.onmouseout=function (e) {
			me.player.setActiveHotspot(null);
			me.elementMouseOver['ht_scaleimage']=false;
			me._tt_ht_node0.logicBlock_visible();
			me.skin.hotspotProxyOut(me.hotspot.id);
		}
		this._ht_scaleimage.ontouchend=function (e) {
			me.elementMouseOver['ht_scaleimage']=false;
			me._tt_ht_node0.logicBlock_visible();
		}
		this._ht_scaleimage.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._ht_node_image0=document.createElement('div');
		this._ht_node_image0__img=document.createElement('img');
		this._ht_node_image0__img.className='ggskin ggskin_svg';
		this._ht_node_image0__img.setAttribute('src',basePath + 'images/ht_node_image0.svg');
		this._ht_node_image0__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;pointer-events:none;;');
		this._ht_node_image0__img['ondragstart']=function() { return false; };
		this._ht_node_image0.appendChild(this._ht_node_image0__img);
		this._ht_node_image0__imgo=document.createElement('img');
		this._ht_node_image0__imgo.className='ggskin ggskin_svg';
		this._ht_node_image0__imgo.setAttribute('src',basePath + 'images/ht_node_image0__o.svg');
		this._ht_node_image0__imgo.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;visibility:hidden;pointer-events:none;;');
		this._ht_node_image0__imgo['ondragstart']=function() { return false; };
		this._ht_node_image0.appendChild(this._ht_node_image0__imgo);
		this._ht_node_image0.ggId="ht_node_image";
		this._ht_node_image0.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._ht_node_image0.ggVisible=true;
		this._ht_node_image0.className="ggskin ggskin_svg ";
		this._ht_node_image0.ggType='svg';
		hs ='';
		hs+='cursor : pointer;';
		hs+='height : 32px;';
		hs+='left : -16px;';
		hs+='position : absolute;';
		hs+='top : -16px;';
		hs+='visibility : inherit;';
		hs+='width : 32px;';
		hs+='pointer-events:auto;';
		this._ht_node_image0.setAttribute('style',hs);
		this._ht_node_image0.style[domTransform + 'Origin']='50% 50%';
		me._ht_node_image0.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._ht_node_image0.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		this._ht_node_image0.onmouseover=function (e) {
			me._ht_node_image0__img.style.visibility='hidden';
			me._ht_node_image0__imgo.style.visibility='inherit';
		}
		this._ht_node_image0.onmouseout=function (e) {
			me._ht_node_image0__img.style.visibility='inherit';
			me._ht_node_image0__imgo.style.visibility='hidden';
		}
		this._ht_node_image0.ggUpdatePosition=function (useTransition) {
		}
		this._ht_scaleimage.appendChild(this._ht_node_image0);
		this._tt_ht_node0=document.createElement('div');
		this._tt_ht_node0__text=document.createElement('div');
		this._tt_ht_node0.className='ggskin ggskin_textdiv';
		this._tt_ht_node0.ggTextDiv=this._tt_ht_node0__text;
		this._tt_ht_node0.ggId="tt_ht_node";
		this._tt_ht_node0.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._tt_ht_node0.ggVisible=false;
		this._tt_ht_node0.className="ggskin ggskin_text ";
		this._tt_ht_node0.ggType='text';
		hs ='';
		hs+='z-index: 100;';
		hs+='height : 20px;';
		hs+='left : -50px;';
		hs+='position : absolute;';
		hs+='top : 21px;';
		hs+='visibility : hidden;';
		hs+='width : 100px;';
		hs+='pointer-events:auto;';
		this._tt_ht_node0.setAttribute('style',hs);
		this._tt_ht_node0.style[domTransform + 'Origin']='50% 50%';
		hs ='position:absolute;';
		hs+='cursor: default;';
		hs+='left: 0px;';
		hs+='top:  0px;';
		hs+='width: auto;';
		hs+='height: auto;';
		hs+='background: #000000;';
		hs+='background: rgba(0,0,0,0.666667);';
		hs+='border: 0px solid #000000;';
		hs+='color: rgba(255,255,255,1);';
		hs+='text-align: center;';
		hs+='white-space: nowrap;';
		hs+='padding: 2px 5px 2px 5px;';
		hs+='overflow: hidden;';
		this._tt_ht_node0__text.setAttribute('style',hs);
		this._tt_ht_node0__text.innerHTML=me.hotspot.title;
		this._tt_ht_node0.appendChild(this._tt_ht_node0__text);
		me._tt_ht_node0.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._tt_ht_node0.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		me._tt_ht_node0.logicBlock_position = function() {
			var newLogicStatePosition;
			if (
				(me.player.getIsMobile() == true)
			)
			{
				newLogicStatePosition = 0;
			}
			else {
				newLogicStatePosition = -1;
			}
			if (me._tt_ht_node0.ggCurrentLogicStatePosition != newLogicStatePosition) {
				me._tt_ht_node0.ggCurrentLogicStatePosition = newLogicStatePosition;
				me._tt_ht_node0.style[domTransition]='left 0s, top 0s';
				if (me._tt_ht_node0.ggCurrentLogicStatePosition == 0) {
					me._tt_ht_node0.style.left='-50px';
					me._tt_ht_node0.style.top='-47px';
				}
				else {
					me._tt_ht_node0.style.left='-50px';
					me._tt_ht_node0.style.top='21px';
				}
			}
		}
		me._tt_ht_node0.logicBlock_visible = function() {
			var newLogicStateVisible;
			if (
				(me.elementMouseOver['ht_scaleimage'] == true)
			)
			{
				newLogicStateVisible = 0;
			}
			else {
				newLogicStateVisible = -1;
			}
			if (me._tt_ht_node0.ggCurrentLogicStateVisible != newLogicStateVisible) {
				me._tt_ht_node0.ggCurrentLogicStateVisible = newLogicStateVisible;
				me._tt_ht_node0.style[domTransition]='left 0s, top 0s';
				if (me._tt_ht_node0.ggCurrentLogicStateVisible == 0) {
					me._tt_ht_node0.style.visibility=(Number(me._tt_ht_node0.style.opacity)>0||!me._tt_ht_node0.style.opacity)?'inherit':'hidden';
					me._tt_ht_node0.ggVisible=true;
				}
				else {
					me._tt_ht_node0.style.visibility="hidden";
					me._tt_ht_node0.ggVisible=false;
				}
			}
		}
		this._tt_ht_node0.ggUpdatePosition=function (useTransition) {
			this.style[domTransition]='none';
			this.ggTextDiv.style.left=((98-this.ggTextDiv.offsetWidth)/2) + 'px';
		}
		this._ht_scaleimage.appendChild(this._tt_ht_node0);
		this.__div = this._ht_scaleimage;
	};
	function SkinHotspotClass_ht_scaleimage2(skinObj,hotspot) {
		var me=this;
		var flag=false;
		var hs='';
		this.player=skinObj.player;
		this.skin=skinObj;
		this.hotspot=hotspot;
		var nodeId=String(hotspot.url);
		nodeId=(nodeId.charAt(0)=='{')?nodeId.substr(1, nodeId.length - 2):'';
		this.ggUserdata=this.skin.player.getNodeUserdata(nodeId);
		this.elementMouseDown=[];
		this.elementMouseOver=[];
		this.findElements=function(id,regex) {
			return me.skin.findElements(id,regex);
		}
		this._ht_scaleimage2=document.createElement('div');
		this._ht_scaleimage2.ggId="ht_scaleimage2";
		this._ht_scaleimage2.ggDx=-116;
		this._ht_scaleimage2.ggDy=-322;
		this._ht_scaleimage2.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._ht_scaleimage2.ggVisible=true;
		this._ht_scaleimage2.className="ggskin ggskin_hotspot ";
		this._ht_scaleimage2.ggType='hotspot';
		hs ='';
		hs+='height : 5px;';
		hs+='left : -10000px;';
		hs+='position : absolute;';
		hs+='top : -10000px;';
		hs+='visibility : inherit;';
		hs+='width : 5px;';
		hs+='pointer-events:auto;';
		this._ht_scaleimage2.setAttribute('style',hs);
		this._ht_scaleimage2.style[domTransform + 'Origin']='50% 50%';
		me._ht_scaleimage2.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._ht_scaleimage2.ggElementNodeId=function() {
			return me.hotspot.url.substr(1, me.hotspot.url.length - 2);
		}
		this._ht_scaleimage2.onclick=function (e) {
			var flag=me.skin._image_2.ggScaleActive;
			if (me.player.transitionsDisabled) {
				me.skin._image_2.style[domTransition]='none';
			} else {
				me.skin._image_2.style[domTransition]='all 500ms ease-out 0ms';
			}
			if (flag) {
				me.skin._image_2.ggParameter.sx=0;me.skin._image_2.ggParameter.sy=0;
				me.skin._image_2.style[domTransform]=parameterToTransform(me.skin._image_2.ggParameter);
			} else {
				me.skin._image_2.ggParameter.sx=1;me.skin._image_2.ggParameter.sy=1;
				me.skin._image_2.style[domTransform]=parameterToTransform(me.skin._image_2.ggParameter);
			}
			me.skin._image_2.ggScaleActive=!flag;
			var list=me.findElements("tt_ht_node",true);
			while(list.length>0) {
				var e=list.pop();
				e.style[domTransition]='none';
				e.style.visibility='hidden';
				e.ggVisible=false;
			}
			me.skin.hotspotProxyClick(me.hotspot.id);
		}
		this._ht_scaleimage2.ondblclick=function (e) {
			me.skin.hotspotProxyDoubleClick(me.hotspot.id);
		}
		this._ht_scaleimage2.onmouseover=function (e) {
			me.player.setActiveHotspot(me.hotspot);
			me.elementMouseOver['ht_scaleimage2']=true;
			me._tt_ht_node.logicBlock_visible();
			me.skin.hotspotProxyOver(me.hotspot.id);
		}
		this._ht_scaleimage2.onmouseout=function (e) {
			me.player.setActiveHotspot(null);
			me.elementMouseOver['ht_scaleimage2']=false;
			me._tt_ht_node.logicBlock_visible();
			me.skin.hotspotProxyOut(me.hotspot.id);
		}
		this._ht_scaleimage2.ontouchend=function (e) {
			me.elementMouseOver['ht_scaleimage2']=false;
			me._tt_ht_node.logicBlock_visible();
		}
		this._ht_scaleimage2.ggUpdatePosition=function (useTransition) {
			if (useTransition==='undefined') {
				useTransition = false;
			}
			if (!useTransition) {
				this.style[domTransition]='none';
			}
			if (this.parentNode) {
				var pw=this.parentNode.clientWidth;
				var w=this.offsetWidth;
					this.style.left=(this.ggDx + pw/2 - w/2) + 'px';
				var ph=this.parentNode.clientHeight;
				var h=this.offsetHeight;
					this.style.top=(this.ggDy + ph/2 - h/2) + 'px';
			}
		}
		this._ht_node_image=document.createElement('div');
		this._ht_node_image__img=document.createElement('img');
		this._ht_node_image__img.className='ggskin ggskin_svg';
		this._ht_node_image__img.setAttribute('src',basePath + 'images/ht_node_image.svg');
		this._ht_node_image__img.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;pointer-events:none;;');
		this._ht_node_image__img['ondragstart']=function() { return false; };
		this._ht_node_image.appendChild(this._ht_node_image__img);
		this._ht_node_image__imgo=document.createElement('img');
		this._ht_node_image__imgo.className='ggskin ggskin_svg';
		this._ht_node_image__imgo.setAttribute('src',basePath + 'images/ht_node_image__o.svg');
		this._ht_node_image__imgo.setAttribute('style','position: absolute;top: 0px;left: 0px;width: 100%;height: 100%;-webkit-user-drag:none;visibility:hidden;pointer-events:none;;');
		this._ht_node_image__imgo['ondragstart']=function() { return false; };
		this._ht_node_image.appendChild(this._ht_node_image__imgo);
		this._ht_node_image.ggId="ht_node_image";
		this._ht_node_image.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._ht_node_image.ggVisible=true;
		this._ht_node_image.className="ggskin ggskin_svg ";
		this._ht_node_image.ggType='svg';
		hs ='';
		hs+='cursor : pointer;';
		hs+='height : 32px;';
		hs+='left : -16px;';
		hs+='position : absolute;';
		hs+='top : -16px;';
		hs+='visibility : inherit;';
		hs+='width : 32px;';
		hs+='pointer-events:auto;';
		this._ht_node_image.setAttribute('style',hs);
		this._ht_node_image.style[domTransform + 'Origin']='50% 50%';
		me._ht_node_image.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._ht_node_image.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		this._ht_node_image.onmouseover=function (e) {
			me._ht_node_image__img.style.visibility='hidden';
			me._ht_node_image__imgo.style.visibility='inherit';
		}
		this._ht_node_image.onmouseout=function (e) {
			me._ht_node_image__img.style.visibility='inherit';
			me._ht_node_image__imgo.style.visibility='hidden';
		}
		this._ht_node_image.ggUpdatePosition=function (useTransition) {
		}
		this._ht_scaleimage2.appendChild(this._ht_node_image);
		this._tt_ht_node=document.createElement('div');
		this._tt_ht_node__text=document.createElement('div');
		this._tt_ht_node.className='ggskin ggskin_textdiv';
		this._tt_ht_node.ggTextDiv=this._tt_ht_node__text;
		this._tt_ht_node.ggId="tt_ht_node";
		this._tt_ht_node.ggParameter={ rx:0,ry:0,a:0,sx:1,sy:1 };
		this._tt_ht_node.ggVisible=false;
		this._tt_ht_node.className="ggskin ggskin_text ";
		this._tt_ht_node.ggType='text';
		hs ='';
		hs+='z-index: 100;';
		hs+='height : 20px;';
		hs+='left : -50px;';
		hs+='position : absolute;';
		hs+='top : 21px;';
		hs+='visibility : hidden;';
		hs+='width : 100px;';
		hs+='pointer-events:auto;';
		this._tt_ht_node.setAttribute('style',hs);
		this._tt_ht_node.style[domTransform + 'Origin']='50% 50%';
		hs ='position:absolute;';
		hs+='cursor: default;';
		hs+='left: 0px;';
		hs+='top:  0px;';
		hs+='width: auto;';
		hs+='height: auto;';
		hs+='background: #000000;';
		hs+='background: rgba(0,0,0,0.666667);';
		hs+='border: 0px solid #000000;';
		hs+='color: rgba(255,255,255,1);';
		hs+='text-align: center;';
		hs+='white-space: nowrap;';
		hs+='padding: 2px 5px 2px 5px;';
		hs+='overflow: hidden;';
		this._tt_ht_node__text.setAttribute('style',hs);
		this._tt_ht_node__text.innerHTML=me.hotspot.title;
		this._tt_ht_node.appendChild(this._tt_ht_node__text);
		me._tt_ht_node.ggIsActive=function() {
			if ((this.parentNode) && (this.parentNode.ggIsActive)) {
				return this.parentNode.ggIsActive();
			}
			return false;
		}
		me._tt_ht_node.ggElementNodeId=function() {
			if ((this.parentNode) && (this.parentNode.ggElementNodeId)) {
				return this.parentNode.ggElementNodeId();
			}
			return me.ggNodeId;
		}
		me._tt_ht_node.logicBlock_position = function() {
			var newLogicStatePosition;
			if (
				(me.player.getIsMobile() == true)
			)
			{
				newLogicStatePosition = 0;
			}
			else {
				newLogicStatePosition = -1;
			}
			if (me._tt_ht_node.ggCurrentLogicStatePosition != newLogicStatePosition) {
				me._tt_ht_node.ggCurrentLogicStatePosition = newLogicStatePosition;
				me._tt_ht_node.style[domTransition]='left 0s, top 0s';
				if (me._tt_ht_node.ggCurrentLogicStatePosition == 0) {
					me._tt_ht_node.style.left='-50px';
					me._tt_ht_node.style.top='-47px';
				}
				else {
					me._tt_ht_node.style.left='-50px';
					me._tt_ht_node.style.top='21px';
				}
			}
		}
		me._tt_ht_node.logicBlock_visible = function() {
			var newLogicStateVisible;
			if (
				(me.elementMouseOver['ht_scaleimage2'] == true)
			)
			{
				newLogicStateVisible = 0;
			}
			else {
				newLogicStateVisible = -1;
			}
			if (me._tt_ht_node.ggCurrentLogicStateVisible != newLogicStateVisible) {
				me._tt_ht_node.ggCurrentLogicStateVisible = newLogicStateVisible;
				me._tt_ht_node.style[domTransition]='left 0s, top 0s';
				if (me._tt_ht_node.ggCurrentLogicStateVisible == 0) {
					me._tt_ht_node.style.visibility=(Number(me._tt_ht_node.style.opacity)>0||!me._tt_ht_node.style.opacity)?'inherit':'hidden';
					me._tt_ht_node.ggVisible=true;
				}
				else {
					me._tt_ht_node.style.visibility="hidden";
					me._tt_ht_node.ggVisible=false;
				}
			}
		}
		this._tt_ht_node.ggUpdatePosition=function (useTransition) {
			this.style[domTransition]='none';
			this.ggTextDiv.style.left=((98-this.ggTextDiv.offsetWidth)/2) + 'px';
		}
		this._ht_scaleimage2.appendChild(this._tt_ht_node);
		this.__div = this._ht_scaleimage2;
	};
	this.addSkinHotspot=function(hotspot) {
		var hsinst = null;
		if (hotspot.skinid=='ht_info') {
			hotspot.skinid = 'ht_info';
			hsinst = new SkinHotspotClass_ht_info(me, hotspot);
			if (!hotspotTemplates.hasOwnProperty(hotspot.skinid)) {
				hotspotTemplates[hotspot.skinid] = [];
			}
			hotspotTemplates[hotspot.skinid].push(hsinst);
			me.callChildLogicBlocksHotspot_ht_info_configloaded();;
			me.callChildLogicBlocksHotspot_ht_info_mouseover();;
		} else
		if (hotspot.skinid=='ht_scaleimage') {
			hotspot.skinid = 'ht_scaleimage';
			hsinst = new SkinHotspotClass_ht_scaleimage(me, hotspot);
			if (!hotspotTemplates.hasOwnProperty(hotspot.skinid)) {
				hotspotTemplates[hotspot.skinid] = [];
			}
			hotspotTemplates[hotspot.skinid].push(hsinst);
			me.callChildLogicBlocksHotspot_ht_scaleimage_configloaded();;
			me.callChildLogicBlocksHotspot_ht_scaleimage_mouseover();;
		} else
		{
			hotspot.skinid = 'ht_scaleimage2';
			hsinst = new SkinHotspotClass_ht_scaleimage2(me, hotspot);
			if (!hotspotTemplates.hasOwnProperty(hotspot.skinid)) {
				hotspotTemplates[hotspot.skinid] = [];
			}
			hotspotTemplates[hotspot.skinid].push(hsinst);
			me.callChildLogicBlocksHotspot_ht_scaleimage2_configloaded();;
			me.callChildLogicBlocksHotspot_ht_scaleimage2_mouseover();;
		}
		return hsinst;
	}
	this.removeSkinHotspots=function() {
		if(hotspotTemplates['ht_info']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_info'].length; i++) {
				hotspotTemplates['ht_info'][i] = null;
			}
		}
		if(hotspotTemplates['ht_scaleimage']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_scaleimage'].length; i++) {
				hotspotTemplates['ht_scaleimage'][i] = null;
			}
		}
		if(hotspotTemplates['ht_scaleimage2']) {
			var i;
			for(i = 0; i < hotspotTemplates['ht_scaleimage2'].length; i++) {
				hotspotTemplates['ht_scaleimage2'][i] = null;
			}
		}
		hotspotTemplates = [];
	}
	this.addSkin();
	me._iframe_site.logicBlock_scaling();
	player.addListener('changenodeid', function(args) { me._iframe_site.logicBlock_scaling(); });
	player.addListener('varchanged_vis_iframe_popup', function(args) { me._iframe_site.logicBlock_scaling(); });
	player.addListener('configloaded', function(args) { me.callChildLogicBlocksHotspot_ht_info_configloaded();me.callChildLogicBlocksHotspot_ht_scaleimage_configloaded();me.callChildLogicBlocksHotspot_ht_scaleimage2_configloaded(); });
	player.addListener('mouseover', function(args) { me.callChildLogicBlocksHotspot_ht_info_mouseover();me.callChildLogicBlocksHotspot_ht_scaleimage_mouseover();me.callChildLogicBlocksHotspot_ht_scaleimage2_mouseover(); });
	player.addListener('hotspotsremoved', function(args) { me.removeSkinHotspots(); });
};